<%@page import="com.pdflib.pdflib" errorPage="error.jsp"%>
<%
    /* $Id: businesscard.jsp,v 1.1 2009/09/16 08:29:20 stm Exp $
     *
     * PDFlib client: creation of a business card with JSP
     */

    int font;
    pdflib p = null;
    int i, blockcontainer, pdipage;
    String infile = "boilerplate.pdf";

    /* This is where font/image/PDF input files live. Adjust as necessary.
     *
     * Note that this directory must also contain the LuciduxSans font
     * outline and metrics files.
     */
    ServletContext context = pageContext.getServletContext();
    String searchpath = context.getRealPath("/WEB-INF/data");

    if (searchpath == null) {
        throw new JspException(
                "Error: Unable to access application data (WAR file not unpacked?)");
    }

    String[][] data = { { "name", "Victor Kraxi" },
        { "business.title", "Chief Paper Officer" },
        { "business.address.line1", "17, Aviation Road" },
        { "business.address.city", "Paperfield" },
        { "business.telephone.voice", "phone +1 234 567-89" },
        { "business.telephone.fax", "fax +1 234 567-98" },
        { "business.email", "victor@kraxi.com" },
        { "business.homepage", "www.kraxi.com" }, };

    byte[] buf;
    ServletOutputStream output;

    p = new pdflib();

    // Generate a PDF in memory; insert a file name to create PDF on disk
    if (p.begin_document("", "") == -1) {
        throw new JspException("Error: " + p.get_apiname() + ": "
                + p.get_errmsg());
    }

    /* Set the search path for fonts and PDF files */
    p.set_parameter("SearchPath", searchpath);

    p.set_info("Creator", "businesscard.jsp");
    p.set_info("Author", "Rainer Ploeckl");
    p.set_info("Title", "PDFlib block processing sample (JSP)");

    blockcontainer = p.open_pdi_document(infile, "");
    if (blockcontainer == -1) {
        throw new JspException("Error: " + p.get_apiname() + ": "
                + p.get_errmsg());
    }

    pdipage = p.open_pdi_page(blockcontainer, 1, "");
    if (pdipage == -1) {
        throw new JspException("Error: " + p.get_apiname() + ": "
                + p.get_errmsg());
    }

    p.begin_page_ext(20, 20, ""); // dummy page size

    // This will adjust the page size to the block container's size.
    p.fit_pdi_page(pdipage, 0, 0, "adjustpage");

    // Fill all text blocks with dynamic data 
    for (i = 0; i < (int) data.length; i++) {
        if (p.fill_textblock(pdipage, data[i][0], data[i][1],
                "embedding encoding=unicode") == -1) {
            System.err.println("Warning: " + p.get_errmsg());
        }
    }

    p.end_page_ext(""); // close page
    p.close_pdi_page(pdipage);

    p.end_document(""); // close PDF document
    p.close_pdi_document(blockcontainer);

    buf = p.get_buffer();

    response.setContentType("application/pdf");
    response.setContentLength(buf.length);
    response.setHeader("Content-Disposition",
            "inline; filename=businesscard.pdf");

    output = response.getOutputStream();
    output.write(buf);
    output.close();

    p.delete();
%>
